function fg_HandleEvents(handle,event,this)
  tag = get(handle,"Tag");
  h = guidata(handle);
  type = h.data.(tag){1};
  h.data.(tag){11} = [];  % reset error tag
  set(handle,"foregroundColor",[0 0 0])
  switch (type)     
      case "L"
          uData = get(handle,"userdata");
          if (numel(uData) > 0)
              items = get(handle,"string");
              set(uData,"string",char(items(get(handle,"value"))));
          end
      case {"I","N","NS","NF"}
          myBeNumber = get(handle,"string");
          switch (type)
            case "N"
                answ = regexp(myBeNumber,this.reInteger);
            case "NS"
              answ = regexp(myBeNumber,this.reSignedInteger);
            case {"I","NF"}
              answ = regexp(myBeNumber,this.reFloating);
          end
          if numel(answ) < 1 
             set(handle,"foregroundColor",[1 0 0]);
             h.data.(tag){11} = 1;  % set error tag
          end
      case "S"
        uData = get(handle,"userdata");
        template = strcat("%.",sprintf("%if",uData.decimals));
        set(uData.handle,"string",sprintf(template,get(handle,"value")));
  end
  guidata(handle,h);
  if (isfield(h.Events,tag))   % there is event?
      f = str2func(h.Events.(tag).handler);
      feval (f, handle, this, this,h.Events.(tag).eventName);      % this,gData.Events.(key).eventName}
  end
end