form = ["FORM,,'Sand Box, wide example',,,static,200;"...
        "T,Text,Text type,,Text default,tooltip;"...
        "T,wText,Wide text type,100,Wide text default;"...
        "N,IntegerType,Integer type,,97 107;"...
        "NF,FloatType,Float type,,0.1 0.9;"...
        "I,Imaginary,Imaginary number,,5 3 -7;"...
        "%S,s,Comment widget;"...
        "S,Temperature,,,36,35 43;"...
        "L,Unit,Combo type,,,mm:millimeter|cm:centimeter|m:meter|km:kilometer;"...
        "C,,Example of combo text,,after,Linked,#347;"...
        "T,Linked,Linked text,20;"...
        "L,Samples,,,,|B:One combo|R:Only radio button|E:Events|F:Errors|N:Numbers;"...
        "Link,Samples Linked;"...
        "H,hidden,'Hidden content with , and;';"...
        "R,Rdb,Radio buttons,,,G:Gaussian|P:Poisson|R:Random;"...
        "%B,fg_Ok,%9998;"...
        "B,fg_Ok,Go;"...
        "CKB,C,Language,,,'C, C++, C#';CKB,Java,Language,,,Java;"];
obj = formGen;
if (exist('OCTAVE_VERSION','builtin'))
%    obj.checkBoxValues = {1,0};
    fGen(obj, form, @handleAnswer);
else
    obj.fGen(formGen,join(form,""),@handleAnswer);
end
function handleAnswer(data)
    noButtons = "L,Unit,Measure Unit,,,mm:millimeter|cm:centimeter|m:meter|km:kilometer;";
    onlyRadio = "FORM,,Simple Radio button,#a1F,modal;R,Distrib,Distribution,,,G:Gaussian|P:Poisson|R:Random;";
    numbers = ["FORM,,Numbers example,Cyan,modal,,100,100,400;"...
            "N,Iteration,Iterations number,,97 107;"...
            "NS,Temperature,,,-50 50;"...
            "NF,Iterati,,,0.1 0.9;"...
            "B,bSqrt,Sqrt,40,Sqrt,Imaginary,Square root;"...
            "C,,Centered blue comment,,center,,#00a;"...
            "I,Imaginary,Imaginary number,,3;"...
            "C,,'Right comment',,right;"...
            "C,,Error comment,,left,,error;"];
    events = ["FORM,,Events example,,modal,,100,100;"...
        "S,Red,,,0.94,0 1;"...
        "S,Green,,,0.94,0 1;"...
        "S,Blue,,,0.94,0 1;"...
        "Event,Magenta,changeColor,changeGround;"...
        "Event,Blue,changeColor,changeGround;"...
        "Event,Green,changeColor,changeGround;"...
        "Event,Red,changeColor,changeGround;"];
    errors = ["FORM,,Form with errors example,teal,,,,,400;"...
              "N,Iterat,Iterations number,,merlu cucu;"...
              "C,,Comment with unknown color,,left,,#7ab1;"...
              "S,Green,,,1.94,0 1;"...
              "Event,Magenta,changeColor,changeGround;"...
              "TX;"];
    data
    if (strcmp(data.fg_Button,"fg_Cancel") || ~isfield(data,"Samples")) 
        return; 
    end
    switch (data.Samples)
        case "B"
            formGen.fGen(formGen,noButtons,@handleOthers);
        case "R"
            formGen.fGen(formGen,onlyRadio,@handleOthers);
        case "E"
            obj = formGen;
            obj.buttonsDim = 45;
            if exist('OCTAVE_VERSION','builtin')
                obj.fGen(obj,events,@handleAnswer);
            else
                btns = "B,fg_Cancel,%10008;B,fg_Reset,%8630;B,fg_Ok,%9998;";
                obj.fGen(obj,strcat(join(events,""),btns),@handleAnswer);
            end            
        case "N"
            if exist('OCTAVE_VERSION','builtin')
                formGen.fGen(formGen,numbers,@handleOthers);
            else
                formGen.fGen(formGen,join(numbers,""),@handleOthers);
            end
         case "F"   % form with errors
            if exist('OCTAVE_VERSION','builtin')
                formGen.fGen(formGen,errors,@handleOthers);
            else
                formGen.fGen(formGen,join(errors,""),@handleOthers);
            end
    end
end
function handleOthers(data)
    data
end